#include <FL/Fl.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Native_File_Chooser.H>
#include <FL/Fl_Double_Window.H>
#include <pthread.h>
#include <unistd.h>

#ifndef nullptr
void *_null_ptr = NULL;
#define NULLPTR _null_ptr
#else
#define NULLPTR nullptr
#endif

Fl_Double_Window *win;
Fl_Box *box;
pthread_t t1;

extern "C" void *loop(void *)
{
  int i = 0;
  const char *l[] = { "--", "\\", "|", "/", 0 };

  while (true) {
    if (i > 3) {
      i = 0;
    }

    Fl::lock();
    box->label(l[i]);
    Fl::unlock();
    Fl::awake(win);

    usleep(100000); /* 100ms */
    i++;
  }
  return NULLPTR;
}

static void fltk_cb(Fl_Widget *) {
  fl_file_chooser("FLTK", "*", NULL);
}

static void gtk_cb(Fl_Widget *) {
  Fl_Native_File_Chooser *gtk = new Fl_Native_File_Chooser(Fl_Native_File_Chooser::BROWSE_FILE);
  gtk->title("FLTK");
  gtk->show();
}

static void close_cb(Fl_Widget *) {
  pthread_cancel(t1);
  win->hide();
}

int main(void)
{
  Fl_Button *b1, *b2;

  win = new Fl_Double_Window(150, 150, "test");
  win->callback(close_cb);
  {
    box = new Fl_Box(0, 0, 60, 60, "--");
    b1 = new Fl_Button(10, 100, 60, 26, "FLTK");
    b2 = new Fl_Button(80, 100, 60, 26, "GTK");
    b1->callback(fltk_cb);
    b2->callback(gtk_cb);
  }
  win->end();

  Fl::lock();

  win->show();
  pthread_create(&t1, 0, &loop, NULLPTR);

  return Fl::run();
}


